#include <iostream.h>
#include <fstream.h>
#include <vector>
#include <list>
#include <string>
#include "campeonato.h"


bool findMatch(const list<string>& ls,string t)
{
  
  list<string>::const_iterator it = ls.begin();

  while(it!=ls.end()){
    if(*it==t)
      return true;
    else
      it++;
  }
  return false;
}


Campeonato::Campeonato()
{

  ifstream idatos("campeonato.dat");

  // Si existe el archivo, cargar campeonato;
  if( idatos.is_open() ){

    cout<<"abriendo archivo campeonato.dat"<<endl;
    string aux,noms;

    getline(idatos,campnom);
    idatos>>anyo;
    getline(idatos,aux);//termina de leer la linea
    getline(idatos,aux);//lee "equipos"

    //obtener los nombres de los equipos
    do{
      getline(idatos,noms);
      if(noms!="fecha")
	nombres_equipos.push_back(noms);
    }while(noms!="fecha");
    
    while(aux!="fechas_cumplidas")
      getline(idatos,aux);
    
    fechas_jug=0;
    do{
      getline(idatos,aux);
      if(aux=="1") fechas_jug++;
    }while(aux=="1");
    
    //cargar equipos
    list<string>::iterator it = nombres_equipos.begin();
    while( it!=nombres_equipos.end() ){
      Equipo team(*it);
      
      if( !team.Cargar_equipo() )
	cout<<"No se pudo cargar equipos"<<endl;
  
      equipos.push_back(team);
      it++;
    }
  
    totalfechas=(2*nombres_equipos.size()-2);
  }


  //Si no existe, crear nuevo campeonato;
  else
  {
      ofstream odatos("campeonato.dat");
      char verif;
      
      fechas_jug=0;

      do{
	cout<<"Por favor, ingrese el nombre del campeonato:";
	cin>>campnom;
	cout<<endl<<"Esta correcto?(S/N):";
	cin>>verif;
      }while(!(verif=='S' || verif=='s') );
   
      odatos<<campnom<<endl;
      
      do{
	cout<<"Ingrese el anyo: ";
	cin>>anyo;
	cout<<"Esta correcto?(S/N):";
	cin>>verif;
      }while( !(verif=='S' || verif=='s') );
      odatos<<anyo<<endl;
     
      cout<<"Por favor, ingrese el nombre de los equipos:"<<endl
	  <<"(Cuando termine, escriba '@'  y presione enter)"<<endl;

      odatos<<"equipos"<<endl;
      string nom;
      int i=1;
      do{
	do{
	  cout<<"Equipo "<<i<<": ";
	  cin>>nom;
	  cout<<"Esta correcto?(S/N):";
	  cin>>verif;
	}while( !(verif=='S' || verif=='s') );
	
	if(nom!="@"){
	  nombres_equipos.push_back(nom);
	  odatos<<nom<<endl;
	}
	i++;
      }while(nom!="@");
      
      totalfechas=(2*nombres_equipos.size()-2);
      
      cout<<"Ahora debe ingresar las fechas:"<<endl;
      
      int n=1;
      do{
	cout<<"Fecha "<<n<<":"<<endl;
	odatos<<"fecha"<<endl<<n<<endl;
	i=1;
	do{
	  cout<<"Partido "<<i<<endl;
	  int j;
	  for(j=0;j<2;j++){
	    verif='N';
	    do{
	      if(j==0)cout<<"Local:";
	      else cout<<"Visita:";
	      cin>>nom;
	      if( !findMatch(nombres_equipos,nom) )
		cout<<"No existe ese equipo"<<endl;
	      else
		verif='S';
	    }while(verif!='S');
	    odatos<<nom<<endl;
	  }
	  
	  if(i<nombres_equipos.size()/2)
	    odatos<<"*"<<endl;
	  
	  i++;
	
	}while( i<= (nombres_equipos.size()/2) );
	
	
	n++;
      }while( n<=totalfechas);

     
      odatos<< "fechas_cumplidas"<<endl;
  }
}

  
void Campeonato::Mostrar_estadisticas()
{
  equipos.sort();
  list<Equipo>::reverse_iterator it = equipos.rbegin();
 
  
  cout<<"Equipo.....\t"<<"PJ\t"<<"PG\t"<<"PE\t"<<"PP\t"
	<<"GF\t"<<"GC\t"<<"DIF\t"<<"Rend\t"<<"PTOS"<<endl;
  while( it!=equipos.rend() ){
   
    it->Mostrar_equipo();
    it++;
  }
}

void Campeonato::Actualizar_estadisticas()
{
  if(data.partidos.size()!=0){
    list<Partido>::iterator itp = data.partidos.begin();
    

    while( itp!=data.partidos.end() ){
      
      list<Equipo>::iterator ite = equipos.begin();
      
      //actualizar equipo local
      while( ite->nombre!=itp->local )
	ite++;
      ite->Actualizar_equipo(itp->lgoles,itp->vgoles);

      //actualizar equipo visita
      ite=equipos.begin();
      while( ite->nombre!=itp->visita )
	ite++;
      ite->Actualizar_equipo(itp->vgoles,itp->lgoles);
      
      itp++;
    }
  
  }
  else
    cout<<"No se puede actualizar estadisticas"<<endl;

}
	
void Campeonato::Guardar_estadisticas()
{
  list<Equipo>::iterator ite = equipos.begin();
  
  //BORRAR CONTENIDO DEL ARCHIVO PARA INGRESAR LOS DATOS NUEVOS
  ofstream dataux("equipos.dat");
  dataux.close();

  
  while( ite!=equipos.end() ){
    if(!(ite->Guardar_equipo() ))
      cout<<"No se pudo guardar datos del equipo: "
	  <<ite->nombre;
    
    ite++;
  }
  data.Guardar_fecha();
  
  ofstream odatos("campeonato.dat",ios::app);

  if(odatos.is_open()){
    odatos<<1<<endl;

  }
}

