#include <iostream.h>
#include <fstream.h>
#include <string>
#include "equipo.h"

//IMPLEMENTACIONES PARA LA CLASE EQUIPO


Equipo::Equipo(const string& name)
{
  int i;
  nombre="";
  puntos = 0;
  
  nombre=name;
  
  for (i=0;i<4;i++) partidos[i]=0;
  
  for(i=0;i<3;i++) goles[i]=0;
  rendimiento=0;
}


//Funcion para cargar datos desde archivo
bool Equipo::Cargar_equipo()
{
  int i;

  ifstream datos("equipos.dat");
  
  if( datos.is_open() ){
    cout<<"Abriendo archivo equipos.dat"<<endl;
    
    string fnom;
  
    //buscar en el archivo el nombre del equipo
    
    do{
      getline(datos,fnom);
      //cout<<fnom<<nombre<<endl;
    }
    while(fnom!=nombre);
     
    //Cargar datos
    for (i=0;i<4;i++) datos>>partidos[i];
    for(i=0;i<3;i++) datos>>goles[i];
    datos>>rendimiento ;
    datos>>puntos;
    datos.close();
    
    
    return(true);
  }
  return(false); 
}  

//Funcion para guardar datos a un archivo

bool Equipo::Guardar_equipo()
{
  int i;
  ofstream datos("equipos.dat",ios::app);
  if( datos.is_open() ){
    
    datos<<nombre<<endl;
    for (i=0;i<4;i++) datos<<partidos[i]<<endl;
    for(i=0;i<3;i++) datos<<goles[i]<<endl;
    datos<<rendimiento<<endl;
    datos<<puntos<<endl;
    
    datos.close();
    return(true);
  }
  return(false);
}


void Equipo::Actualizar_equipo(const int& tgol,const int& cgol)
{
  //Aumentar los partidos jugados
  partidos[0]++;

  //El equipo gano
  if ( tgol> cgol) partidos[1]++;
  
  //El equipo empato
  else if( tgol==cgol) partidos[2]++;
  
  //El equipo perdio
  else partidos[3]++;
  
  //Los puntos

  puntos = 3*partidos[1]+partidos[2];

  //Los goles

  goles[0]+=tgol;
  goles[1]+=cgol;
  goles[2]=goles[0]-goles[1];

  //Calcular el rendimiento

  float ideal = (float)partidos[0]*3;
  rendimiento = 100*(float)puntos/ideal;

}

void Equipo::Mostrar_equipo()
{
  cout<<nombre<<"....."<<'\t'<<partidos[0]<<'\t'<<partidos[1]<<'\t'<<
    partidos[2]<<'\t'<<partidos[3]<<'\t'<<goles[0]<<'\t'<<
    goles[1]<<'\t'<<goles[2]<<'\t'<<rendimiento<<'\t'<<puntos<<endl;
  
}

bool Equipo::operator<(const Equipo& team) const
{
  
  if( this->puntos<team.puntos )
    return true;
  else if( this->puntos==team.puntos ){
    if( this->goles[2]<team.goles[2] )
      return true;

    else if( this->goles[0]<team.goles[0] )
      return true;
  }
  else
    return false;
  
}
    
