#include <fstream.h>
#include <list>
#include "fecha.h"


bool Fecha::Nueva_fecha(const int& numero)
{
  string fechas,aux;
  ifstream datos("campeonato.dat");
  
  
  if( datos.is_open() ){
    
    partidos.clear();
    cout<<"Abriendo archivo: campeonato.dat"<<endl;
    
    //buscar la fecha dentro del archivo
    while( !datos.eof() ){
      do
	getline(datos,fechas);
      while(fechas!="fecha");  
      datos>>nro_fecha;
      getline(datos,aux);//para terminar de leer la linea
      if( nro_fecha==numero )
	break;
    }
    //si no se encontro la fecha
    if( nro_fecha!=numero )
      return(false);
    
    //obtener los partidos y guardarlos en la lista
    Partido match;
    while( aux!= "fecha" && aux!="fechas_cumplidas" ){
      
      getline(datos, match.local);
      getline(datos, match.visita);
      getline(datos, aux);
      
      //ingresar el resultado del partido

      cout<<"Por favor, ingrese el resultado del partido: "<<
	  match.local<<" vs "<<match.visita<<endl;
      cout<<match.local<<": ";
      cin>>match.lgoles;
      cout<<match.visita<<": ";
      cin>>match.vgoles;

      

      partidos.push_back( match );
      
    }
    datos.close();
    return(true);
  }
}

bool Fecha::Cargar_fecha(const int& numero)
{
  string fechas,aux;

  
  ifstream datos("fechas.dat");
  if( datos.is_open() ){
    cout<<"Abriendo archivo: fechas.dat"<<endl;
    
    partidos.clear();
    //buscar la fecha dentro del archivo
    while( !datos.eof() ){
      do
	getline(datos,fechas);
      while(fechas!="fecha");  
      datos>>nro_fecha;
      getline(datos,aux);//para terminar de leer la linea
      if( nro_fecha==numero )
	break;
    }
    //si no se encontro la fecha
    if( nro_fecha!=numero )
      return(false);
    
    //obtener los partidos y guardarlos en la lista
    Partido match;
    while( aux!= "@" ){
      
      getline(datos, match.local);
      datos>>match.lgoles;
      getline(datos, aux);
      getline(datos, match.visita);
      datos>>match.vgoles;
      getline(datos, aux);
      getline(datos, aux);
      partidos.push_back( match );
      
    }
    datos.close();
    return(true);
  } 
}

void Fecha::Mostrar_fecha()
{
  if(partidos.size()>0){
    int i=1;
    pit = partidos.begin();
    cout<<"Fecha numero: "<<nro_fecha<<endl<<endl;
    while( pit != partidos.end() ){
      
      cout<<"Partido: "<<i<<endl;
      cout<<pit->local<<": "<<pit->lgoles<<endl;
      cout<<pit->visita<<": "<<pit->vgoles<<endl<<endl;
 
      pit++;
      i++;
    }
  }    
}


bool Fecha::Guardar_fecha()
{
  ofstream datos("fechas.dat",ios::app);
  
  if( datos.is_open() && partidos.size()>0 ){
    
    datos<<"fecha"<<endl;
    datos<<nro_fecha<<endl;
    
    pit = partidos.begin();
    list<Partido>::iterator pend=partidos.end();
    --pend;//apunta al ultimo elemento

    while( pit!=partidos.end() ){
      datos<<pit->local<<endl;
      datos<<pit->lgoles<<endl;
      datos<<pit->visita<<endl;
      datos<<pit->vgoles<<endl;
      
      if(pit!=pend)
	 datos<<"*"<<endl;
      else
	datos<<"@"<<endl;
      
      pit++;
    }
    
    datos.close();
    return(true);
  }
  return(false);
}
